searchNodes=[{"doc":"Apollo Federation support for Absinthe . Examples Schemas should use Absinthe.Federation.Schema defmodule MyApp.MySchema do use Absinthe.Schema + use Absinthe.Federation.Schema query do ... end end For a type module, use Absinthe.Federation.Notation instead: defmodule MyApp.MySchema.Types do use Absinthe.Schema.Notation + use Absinthe.Federation.Notation end","ref":"Absinthe.Federation.html","title":"Absinthe.Federation","type":"module"},{"doc":"See Absinthe.Federation.Schema.remove_federated_types_pipeline/1 .","ref":"Absinthe.Federation.html#remove_federated_types_pipeline/1","title":"Absinthe.Federation.remove_federated_types_pipeline/1","type":"function"},{"doc":"See Absinthe.Federation.Schema.to_federated_sdl/1 .","ref":"Absinthe.Federation.html#to_federated_sdl/1","title":"Absinthe.Federation.to_federated_sdl/1","type":"function"},{"doc":"Module that includes macros for annotating a schema with federation directives. Example defmodule MyApp.MySchema.Types do use Absinthe.Schema.Notation + use Absinthe.Federation.Notation end","ref":"Absinthe.Federation.Notation.html","title":"Absinthe.Federation.Notation","type":"module"},{"doc":"The @authenticated directive marks specific fields and types as requiring authentication. Example object :secret do field :text , :string do authenticated ( ) end end SDL Output type Secret { text : String @authenticated }","ref":"Absinthe.Federation.Notation.html#authenticated/0","title":"Absinthe.Federation.Notation.authenticated/0","type":"macro"},{"doc":"The @context directive defines a named context from which a field of the annotated type can be passed to a receiver of the context. The receiver must be a field annotated with the @fromContext directive. Example object :user do context ( &quot;userContext&quot; ) field :id , non_null ( :id ) field :name , :string end SDL Output type User @context ( name : &quot;userContext&quot; ) { id : ID ! name : String }","ref":"Absinthe.Federation.Notation.html#context/1","title":"Absinthe.Federation.Notation.context/1","type":"macro"},{"doc":"The @cost directive defines a custom weight for a schema location. For GraphOS Router, it customizes the operation cost calculation of the demand control feature. Example object :user do field :posts , list_of ( :post ) do cost ( 5 ) resolve &amp; PostResolvers . list_for_user / 3 end end SDL Output type User { posts : [ Post ] @cost ( weight : 5 ) }","ref":"Absinthe.Federation.Notation.html#cost/1","title":"Absinthe.Federation.Notation.cost/1","type":"macro"},{"doc":"Adds the @extends directive to the type to indicate that the type as owned by another service. Example object :user do extends ( ) key_fields ( &quot;id&quot; ) field :id , non_null ( :id ) end SDL Output type User @key ( fields : &quot;id&quot; ) @extends { id : ID ! }","ref":"Absinthe.Federation.Notation.html#extends/0","title":"Absinthe.Federation.Notation.extends/0","type":"macro"},{"doc":"Adds the @external directive to the field which marks a field as owned by another service. This allows service A to use fields from service B while also knowing at runtime the types of that field. Example object :user do extends ( ) key_fields ( &quot;email&quot; ) field :email , :string do external ( ) end field :reviews , list_of ( :review ) end SDL Output # extended from the Users service type User @key ( fields : &quot;email&quot; ) @extends { email : String @external reviews : [ Review ] } This type extension in the Reviews service extends the User type from the Users service. It extends it for the purpose of adding a new field called reviews, which returns a list of Review s.","ref":"Absinthe.Federation.Notation.html#external/0","title":"Absinthe.Federation.Notation.external/0","type":"macro"},{"doc":"The @inaccessible directive indicates that a field or type should be omitted from the gateway's API schema, even if it's also defined in other subgraphs. Example object :user do key_fields ( &quot;id&quot; ) field :id , non_null ( :id ) field :name , :string do inaccessible ( ) end end SDL Output type User @key ( fields : &quot;id&quot; ) { id : ID ! name : String @inaccessible }","ref":"Absinthe.Federation.Notation.html#inaccessible/0","title":"Absinthe.Federation.Notation.inaccessible/0","type":"macro"},{"doc":"Adds the @interfaceObject directive to the field which indicates that the object definition serves as an abstraction of another subgraph's entity interface. This abstraction enables a subgraph to automatically contribute fields to all entities that implement a particular entity interface. During composition, the fields of every @interfaceObject are added both to their corresponding interface definition and to all entity types that implement that interface. More information can be found on: https://www.apollographql.com/docs/federation/federated-types/interfaces Example object :media do key_fields ( &quot;id&quot; ) interface_object ( ) field :id , non_null ( :id ) , do : external ( ) field :reviews , non_null ( list_of ( non_null ( :review ) ) ) end object :review do field :score , non_null ( :integer ) end SDL Output type Media @interfaceObject @key ( fields : &quot;id&quot; ) { id : ID ! @external reviews : [ Review ! ] ! } type Review { score : Int ! }","ref":"Absinthe.Federation.Notation.html#interface_object/0","title":"Absinthe.Federation.Notation.interface_object/0","type":"macro"},{"doc":"Adds a @key directive to the type which indicates a combination of fields that can be used to uniquely identify and fetch an object or interface. This allows the type to be extended by other services. A string rather than atom is used here to support composite keys e.g. id organization { id } Example object :user do key_fields ( &quot;id&quot; ) field :id , non_null ( :id ) end SDL Output type User @key ( fields : &quot;id&quot; ) { id : ID ! }","ref":"Absinthe.Federation.Notation.html#key_fields/1","title":"Absinthe.Federation.Notation.key_fields/1","type":"macro"},{"doc":"The @link directive links definitions from an external specification to this schema. Every Federation 2 subgraph uses the @link directive to import the other federation-specific directives. NOTE: If you're using Absinthe v1.7.1 or later, instead of using this macro, it's preferred to use the extend schema method you can find in the README . Example link ( url : &quot;https://specs.apollo.dev/federation/v2.0&quot; , import : [ &quot;@key&quot; , &quot;@tag&quot; , &quot;@shareable&quot; ] ) query do field :me , :user end object :user do key_fields ( &quot;id&quot; ) shareable ( ) field :id , non_null ( :id ) field :ssn , :string do tag ( &quot;internal&quot; ) end end SDL Output schema @link ( url : &quot;url: https: \\/ \\/ specs.apollo.dev \\/ federation \\/ v2.0&quot; , import : [ &quot;@key&quot; , &quot;@tag&quot; , &quot;@shareable&quot; ] ) type User @key ( fields : &quot;id&quot; ) @shareable { id : ID ! name : String @tag ( name : &quot;internal&quot; ) }","ref":"Absinthe.Federation.Notation.html#link/1","title":"Absinthe.Federation.Notation.link/1","type":"macro"},{"doc":"The @listSize directive is used to customize the cost calculation of the demand control feature of GraphOS Router. Example object :post do field :text , :string end object :user do field :posts , non_null ( list_of ( :post ) ) do list_size ( assumed_size : 10 , slicing_arguments : [ &quot;first&quot; , &quot;last&quot; ] , sized_fields : [ &quot;postCount&quot; ] , required_one_slicing_argument : false ) arg :first , :integer arg :last , :integer end end SDL Output type User { posts ( first : Int , last : Int ) : [ Post ] ! @listSize ( assumedSize : 10 , slicingArguments : [ &quot;first&quot; , &quot;last&quot; ] , sizedFields : [ &quot;postCount&quot; ] , requiredOneSlicingArgument : false ) }","ref":"Absinthe.Federation.Notation.html#list_size/1","title":"Absinthe.Federation.Notation.list_size/1","type":"macro"},{"doc":"The @override directive is used to indicate that the current subgraph is taking responsibility for resolving the marked field away from the subgraph specified in the from argument. The progressive @override feature enables the gradual, progressive deployment of a subgraph with an @override field. As a subgraph developer, you can customize the percentage of traffic that the overriding and overridden subgraphs each resolve for a field. Example # @override object :user do key_fields ( &quot;id&quot; ) field :id , non_null ( :id ) field :name , :string do override_from ( &quot;SubgraphA&quot; ) end end # progressive @override object :user do key_fields ( &quot;id&quot; ) field :id , non_null ( :id ) field :name , :string do override_from ( &quot;SubgraphA&quot; , label : &quot;percent(10)&quot; ) end end SDL Output # @override type User @key ( fields : &quot;id&quot; ) { id : ID ! name : String @override ( from : &quot;SubgraphA&quot; ) } # progressive @override type User @key ( fields : &quot;id&quot; ) { id : ID ! name : String @override ( from : &quot;SubgraphA&quot; , label : &quot;percent(10)&quot; ) }","ref":"Absinthe.Federation.Notation.html#override_from/2","title":"Absinthe.Federation.Notation.override_from/2","type":"macro"},{"doc":"The @policy directive marks fields and types as restricted based on authorization policies evaluated in a Rhai script or coprocessor. This enables custom authorization validation beyond authentication and scopes. Example object :user do field :id , non_null ( :id ) field :username , :string field :email , :string field :profile_image , :string field :credit_card , :string do policy ( [ [ &quot;read_credit_card&quot; ] ] ) end end SDL Output type User { id : ID ! username : String email : String profileImage : String credit_card : String @policy ( policies : [ [ &quot;read_credit_card&quot; ] ] ) }","ref":"Absinthe.Federation.Notation.html#policy/1","title":"Absinthe.Federation.Notation.policy/1","type":"macro"},{"doc":"Adds the @provides directive which is used to annotate the expected returned fieldset from a field on a base type that is guaranteed to be selectable by the gateway. Example object :review do key_fields ( &quot;id&quot; ) field :id , non_null ( :id ) field :product , :product do provides_fields ( &quot;name&quot; ) end end object :product do extends ( ) key_fields ( &quot;upc&quot; ) field :upc , :string do external ( ) end field :name , :string do external ( ) end end SDL Output type Review @key ( fields : &quot;id&quot; ) { product : Product @provides ( fields : &quot;name&quot; ) } type Product @key ( fields : &quot;upc&quot; ) @extends { upc : String @external name : String @external } When fetching Review.product from the Reviews service, it is possible to request the name with the expectation that the Reviews service can provide it when going from review to product. Product.name is an external field on an external type which is why the local type extension of Product and annotation of name is required.","ref":"Absinthe.Federation.Notation.html#provides_fields/1","title":"Absinthe.Federation.Notation.provides_fields/1","type":"macro"},{"doc":"Adds the @requires directive which is used to annotate the required input fieldset from a base type for a resolver. It is used to develop a query plan where the required fields may not be needed by the client, but the service may need additional information from other services. Example object :user do extends ( ) key_fields ( &quot;id&quot; ) field :id , non_null ( :id ) do external ( ) end field :email , :string do external ( ) end field :reviews , list_of ( :review ) do requires_fields ( &quot;email&quot; ) end end SDL Output # extended from the Users service type User @key ( fields : &quot;id&quot; ) @extends { id : ID ! @external email : String @external reviews : [ Review ] @requires ( fields : &quot;email&quot; ) } In this case, the Reviews service adds new capabilities to the User type by providing a list of reviews related to a User . In order to fetch these reviews , the Reviews service needs to know the email of the User from the Users service in order to look up the reviews . This means the reviews field / resolver requires the email field from the base User type.","ref":"Absinthe.Federation.Notation.html#requires_fields/1","title":"Absinthe.Federation.Notation.requires_fields/1","type":"macro"},{"doc":"The @requiresScopes directive marks fields and types as restricted based on required scopes. Example object :user do field :id , non_null ( :id ) field :username , :string field :email , :string do requires_scopes ( [ [ &quot;read:email&quot; ] ] ) end field :profile_image , :string end SDL Output type User { id : ID ! username : String email : String @requiresScopes ( scopes : [ [ &quot;read:email&quot; ] ] ) profileImage : String }","ref":"Absinthe.Federation.Notation.html#requires_scopes/1","title":"Absinthe.Federation.Notation.requires_scopes/1","type":"macro"},{"doc":"Adds the @shareable directive to the type to indicate that a field can be resolved by multiple subgraphs. Example object :user do key_fields ( &quot;id&quot; ) shareable ( ) field :id , non_null ( :id ) end SDL Output type User @key ( fields : &quot;id&quot; ) @shareable { id : ID ! }","ref":"Absinthe.Federation.Notation.html#shareable/0","title":"Absinthe.Federation.Notation.shareable/0","type":"macro"},{"doc":"The @tag directive indicates whether to include or exclude the field/type from your contract schema. Example object :user do key_fields ( &quot;id&quot; ) field :id , non_null ( :id ) field :ssn , :string do tag ( &quot;internal&quot; ) end end SDL Output type User @key ( fields : &quot;id&quot; ) { id : ID ! name : String @tag ( name : &quot;internal&quot; ) }","ref":"Absinthe.Federation.Notation.html#tag/1","title":"Absinthe.Federation.Notation.tag/1","type":"macro"},{"doc":"Module for injecting custom Absinthe.Phase s for adding federated types and directives. Example defmodule MyApp.MySchema do use Absinthe.Schema + use Absinthe.Federation.Schema query do ... end end","ref":"Absinthe.Federation.Schema.html","title":"Absinthe.Federation.Schema","type":"module"},{"doc":"Injects custom compile-time Absinthe.Phase","ref":"Absinthe.Federation.Schema.html#pipeline/1","title":"Absinthe.Federation.Schema.pipeline/1","type":"function"},{"doc":"","ref":"Absinthe.Federation.Schema.html#remove_federated_types_pipeline/1","title":"Absinthe.Federation.Schema.remove_federated_types_pipeline/1","type":"function"},{"doc":"","ref":"Absinthe.Federation.Schema.html#to_federated_sdl/1","title":"Absinthe.Federation.Schema.to_federated_sdl/1","type":"function"},{"doc":"","ref":"Absinthe.Federation.Schema.EntityUnion.Resolver.html","title":"Absinthe.Federation.Schema.EntityUnion.Resolver","type":"protocol"},{"doc":"","ref":"Absinthe.Federation.Schema.EntityUnion.Resolver.html#resolve_type/2","title":"Absinthe.Federation.Schema.EntityUnion.Resolver.resolve_type/2","type":"function"},{"doc":"All the types that implement this protocol.","ref":"Absinthe.Federation.Schema.EntityUnion.Resolver.html#t:t/0","title":"Absinthe.Federation.Schema.EntityUnion.Resolver.t/0","type":"type"},{"doc":"https://www.apollographql.com/docs/federation/federation-spec/#query_service The federation schema modifications (i.e. new types and directive definitions) should not be included in this SDL.","ref":"Absinthe.Federation.Schema.Phase.AddFederatedTypes.html","title":"Absinthe.Federation.Schema.Phase.AddFederatedTypes","type":"module"},{"doc":"","ref":"Absinthe.Federation.Schema.Phase.AddFederatedTypes.html#flag_invalid/1","title":"Absinthe.Federation.Schema.Phase.AddFederatedTypes.flag_invalid/1","type":"function"},{"doc":"","ref":"Absinthe.Federation.Schema.Phase.AddFederatedTypes.html#flag_invalid/2","title":"Absinthe.Federation.Schema.Phase.AddFederatedTypes.flag_invalid/2","type":"function"},{"doc":"","ref":"Absinthe.Federation.Schema.Phase.AddFederatedTypes.html#flag_invalid/3","title":"Absinthe.Federation.Schema.Phase.AddFederatedTypes.flag_invalid/3","type":"function"},{"doc":"","ref":"Absinthe.Federation.Schema.Phase.AddFederatedTypes.html#inherit_invalid/3","title":"Absinthe.Federation.Schema.Phase.AddFederatedTypes.inherit_invalid/3","type":"function"},{"doc":"","ref":"Absinthe.Federation.Schema.Phase.AddFederatedTypes.html#put_flag/2","title":"Absinthe.Federation.Schema.Phase.AddFederatedTypes.put_flag/2","type":"function"},{"doc":"Callback implementation for Absinthe.Phase.run/2 .","ref":"Absinthe.Federation.Schema.Phase.AddFederatedTypes.html#run/2","title":"Absinthe.Federation.Schema.Phase.AddFederatedTypes.run/2","type":"function"},{"doc":"","ref":"Absinthe.Federation.Schema.Phase.Validation.KeyFieldsMustBeValidWhenExtends.html","title":"Absinthe.Federation.Schema.Phase.Validation.KeyFieldsMustBeValidWhenExtends","type":"module"},{"doc":"","ref":"Absinthe.Federation.Schema.Phase.Validation.KeyFieldsMustBeValidWhenExtends.html#explanation/2","title":"Absinthe.Federation.Schema.Phase.Validation.KeyFieldsMustBeValidWhenExtends.explanation/2","type":"function"},{"doc":"","ref":"Absinthe.Federation.Schema.Phase.Validation.KeyFieldsMustBeValidWhenExtends.html#explanation/3","title":"Absinthe.Federation.Schema.Phase.Validation.KeyFieldsMustBeValidWhenExtends.explanation/3","type":"function"},{"doc":"","ref":"Absinthe.Federation.Schema.Phase.Validation.KeyFieldsMustBeValidWhenExtends.html#flag_invalid/1","title":"Absinthe.Federation.Schema.Phase.Validation.KeyFieldsMustBeValidWhenExtends.flag_invalid/1","type":"function"},{"doc":"","ref":"Absinthe.Federation.Schema.Phase.Validation.KeyFieldsMustBeValidWhenExtends.html#flag_invalid/2","title":"Absinthe.Federation.Schema.Phase.Validation.KeyFieldsMustBeValidWhenExtends.flag_invalid/2","type":"function"},{"doc":"","ref":"Absinthe.Federation.Schema.Phase.Validation.KeyFieldsMustBeValidWhenExtends.html#flag_invalid/3","title":"Absinthe.Federation.Schema.Phase.Validation.KeyFieldsMustBeValidWhenExtends.flag_invalid/3","type":"function"},{"doc":"","ref":"Absinthe.Federation.Schema.Phase.Validation.KeyFieldsMustBeValidWhenExtends.html#inherit_invalid/3","title":"Absinthe.Federation.Schema.Phase.Validation.KeyFieldsMustBeValidWhenExtends.inherit_invalid/3","type":"function"},{"doc":"","ref":"Absinthe.Federation.Schema.Phase.Validation.KeyFieldsMustBeValidWhenExtends.html#put_flag/2","title":"Absinthe.Federation.Schema.Phase.Validation.KeyFieldsMustBeValidWhenExtends.put_flag/2","type":"function"},{"doc":"Run validate","ref":"Absinthe.Federation.Schema.Phase.Validation.KeyFieldsMustBeValidWhenExtends.html#run/2","title":"Absinthe.Federation.Schema.Phase.Validation.KeyFieldsMustBeValidWhenExtends.run/2","type":"function"},{"doc":"","ref":"Absinthe.Federation.Schema.Phase.Validation.KeyFieldsMustExist.html","title":"Absinthe.Federation.Schema.Phase.Validation.KeyFieldsMustExist","type":"module"},{"doc":"","ref":"Absinthe.Federation.Schema.Phase.Validation.KeyFieldsMustExist.html#explanation/2","title":"Absinthe.Federation.Schema.Phase.Validation.KeyFieldsMustExist.explanation/2","type":"function"},{"doc":"","ref":"Absinthe.Federation.Schema.Phase.Validation.KeyFieldsMustExist.html#explanation/3","title":"Absinthe.Federation.Schema.Phase.Validation.KeyFieldsMustExist.explanation/3","type":"function"},{"doc":"","ref":"Absinthe.Federation.Schema.Phase.Validation.KeyFieldsMustExist.html#flag_invalid/1","title":"Absinthe.Federation.Schema.Phase.Validation.KeyFieldsMustExist.flag_invalid/1","type":"function"},{"doc":"","ref":"Absinthe.Federation.Schema.Phase.Validation.KeyFieldsMustExist.html#flag_invalid/2","title":"Absinthe.Federation.Schema.Phase.Validation.KeyFieldsMustExist.flag_invalid/2","type":"function"},{"doc":"","ref":"Absinthe.Federation.Schema.Phase.Validation.KeyFieldsMustExist.html#flag_invalid/3","title":"Absinthe.Federation.Schema.Phase.Validation.KeyFieldsMustExist.flag_invalid/3","type":"function"},{"doc":"","ref":"Absinthe.Federation.Schema.Phase.Validation.KeyFieldsMustExist.html#inherit_invalid/3","title":"Absinthe.Federation.Schema.Phase.Validation.KeyFieldsMustExist.inherit_invalid/3","type":"function"},{"doc":"","ref":"Absinthe.Federation.Schema.Phase.Validation.KeyFieldsMustExist.html#put_flag/2","title":"Absinthe.Federation.Schema.Phase.Validation.KeyFieldsMustExist.put_flag/2","type":"function"},{"doc":"Run validate","ref":"Absinthe.Federation.Schema.Phase.Validation.KeyFieldsMustExist.html#run/2","title":"Absinthe.Federation.Schema.Phase.Validation.KeyFieldsMustExist.run/2","type":"function"},{"doc":"","ref":"Absinthe.Federation.Schema.Phase.Validation.Util.html","title":"Absinthe.Federation.Schema.Phase.Validation.Util","type":"module"},{"doc":"","ref":"Absinthe.Federation.Schema.Phase.Validation.Util.html#is_nested?/1","title":"Absinthe.Federation.Schema.Phase.Validation.Util.is_nested?/1","type":"function"},{"doc":"","ref":"Absinthe.Federation.Schema.Phase.Validation.Util.html#no_object_error/3","title":"Absinthe.Federation.Schema.Phase.Validation.Util.no_object_error/3","type":"function"},{"doc":"","ref":"Absinthe.Federation.Schema.Phase.Validation.Util.html#parse_key_fields/1","title":"Absinthe.Federation.Schema.Phase.Validation.Util.parse_key_fields/1","type":"function"},{"doc":"","ref":"Absinthe.Federation.Schema.Phase.Validation.Util.html#syntax_error/2","title":"Absinthe.Federation.Schema.Phase.Validation.Util.syntax_error/2","type":"function"},{"doc":"Generate a schema.graphql file. Usage mix absinthe . federation . schema . sdl [ OPTIONS ] [ FILENAME ] Options --schema - The name of the Absinthe.Schema module defining the schema to be generated. Default: As configured for :absinthe :schema Examples Write to default path ./schema.graphql using the :schema configured for the :absinthe application: mix absinthe . federation . schema . sdl Write to path /path/to/schema.graphql using the MySchema schema mix absinthe . federation . schema . sdl -- schema MySchema / path / to / schema . graphql","ref":"Mix.Tasks.Absinthe.Federation.Schema.Sdl.html","title":"Mix.Tasks.Absinthe.Federation.Schema.Sdl","type":"task"},{"doc":"","ref":"Mix.Tasks.Absinthe.Federation.Schema.Sdl.html#generate_schema/1","title":"Mix.Tasks.Absinthe.Federation.Schema.Sdl.generate_schema/1","type":"function"},{"doc":"","ref":"Mix.Tasks.Absinthe.Federation.Schema.Sdl.html#parse_options/1","title":"Mix.Tasks.Absinthe.Federation.Schema.Sdl.parse_options/1","type":"function"},{"doc":"Apollo Federation support for Absinthe .","ref":"readme.html","title":"Absinthe.Federation","type":"extras"},{"doc":"Install from Hex : def deps do [ { :absinthe_federation , &quot;~&gt; 0.7&quot; } ] end Install a specific branch from GitHub : def deps do [ { :absinthe_federation , github : &quot;DivvyPayHQ/absinthe_federation&quot; , branch : &quot;main&quot; } ] end Use Absinthe.Federation.Schema module in your root schema: defmodule Example.Schema do use Absinthe.Schema + use Absinthe.Federation.Schema query do ... end end Validate everything is wired up correctly: mix absinthe.federation.schema.sdl --schema Example.Schema You should see the Apollo Federation Subgraph Specification fields along with any fields you've defined. It can be helpful to add *.graphql to your .gitignore , at least at your projects root level, while testing your SDL output during development.","ref":"readme.html#installation","title":"Absinthe.Federation - Installation","type":"extras"},{"doc":"The following sticks close to the Apollo Federation documentation to better clarify how to achieve the same outcomes with the Absinthe.Federation module as you'd get from their JavaScript examples. Defining an entity defmodule Products.Schema do use Absinthe.Schema use Absinthe.Federation.Schema extend schema do directive ( :link , url : &quot;https://specs.apollo.dev/federation/v2.3&quot; , import : [ &quot;@key&quot; , ... ] ) end object :product do directive :key , fields : &quot;id&quot; # Any subgraph contributing fields MUST define a _resolve_reference field. field :_resolve_reference , :product do resolve &amp; Products . find_by_id / 2 end field :id , non_null ( :id ) field :name , non_null ( :string ) field :price , :int end query do ... end end Your :_resolve_reference must return one of the following: { :ok , % Product { id : id , ... } } { :ok , %{ __typename : &quot;Product&quot; , id : id , ... } } { :ok , %{ &quot;__typename&quot; =&gt; &quot;Product&quot; , &quot;id&quot; =&gt; id , ... } } { :ok , nil } It is easier to just merge a subgraph's contributed fields back onto the incoming entity reference than rely on a struct to set the __typename . Contributing entity fields Each subgraph, by default, must return different fields. See the Apollo documentation should you need to override this behavior . defmodule Inventory.Schema do use Absinthe.Schema use Absinthe.Federation.Schema extend schema do directive ( :link , url : &quot;https://specs.apollo.dev/federation/v2.3&quot; , import : [ &quot;@key&quot; , ... ] ) end object :product do directive :key , fields : &quot;id&quot; # In this case, only the `Inventory.Schema` should resolve the `inStock` field. field :_resolve_reference , :product do resolve ( fn %{ __typename : &quot;Product&quot; , id : id } = entity , _info -&gt; { :ok , Map . merge ( entity , %{ in_stock : true } ) } end ) end field :id , non_null ( :string ) field :in_stock , non_null ( :boolean ) end query do ... end end Referencing an entity without contributing fields defmodule Reviews.Schema do use Absinthe.Schema use Absinthe.Federation.Schema extend schema do directive ( :link , url : &quot;https://specs.apollo.dev/federation/v2.3&quot; , import : [ &quot;@key&quot; , ... ] ) end # Stubbed entity, marked as unresolvable in this subgraph. object :product do directive :key , fields : &quot;id&quot; , resolvable : false field :id , non_null ( :string ) end object :review do field :id , non_null ( :id ) field :score , non_null ( :int ) field :description , non_null ( :string ) # This subgraph only needs to resolve the key fields used to reference the entity. field :product , non_null ( :product ) do resolve ( fn %{ product_id : id } = _parent , _args , _info -&gt; { :ok , %{ id : id } } end ) end end query do field :latest_reviews , non_null ( list ( :review ) ) do resolve ( &amp; ReviewsResolver . find_many / 2 ) end end end Macro based schema with existing prototype If you are already using a schema prototype. defmodule Example.Schema do use Absinthe.Schema + use Absinthe.Federation.Schema , prototype_schema : Example.SchemaPrototype query do ... end end defmodule Example.SchemaPrototype do use Absinthe.Schema.Prototype + use Absinthe.Federation.Schema.Prototype.FederatedDirectives directive :my_directive do on [ :schema ] end end SDL based schemas (experimental) defmodule Example.Schema do use Absinthe.Schema + use Absinthe.Federation.Schema import_sdl &quot;&quot;&quot; extend type Query { review(id: ID!): Review } extend type Product @key(fields: &quot;upc&quot;) { upc: String! @external reviews: [Review] } &quot;&quot;&quot; def hydrate ( _ , _ ) do ... end end Using Dataloader in _resolve_reference queries You can use Dataloader in to resolve references to specific objects, but it requires manually setting up the batch and item key, as the field has no parent. Resolution for both _resolve_reference fields are functionally equivalent. defmodule Example.Schema do use Absinthe.Schema use Absinthe.Federation.Schema import Absinthe.Resolution.Helpers , only : [ on_load : 2 , dataloader : 2 ] def context ( ctx ) do loader = Dataloader . new ( ) |&gt; Dataloader . add_source ( Example.Loader , Dataloader.Ecto . new ( Example.Repo ) ) Map . put ( ctx , :loader , loader ) end def plugins do [ Absinthe.Middleware.Dataloader ] ++ Absinthe.Plugin . defaults ( ) end object :item do key_fields ( &quot;item_id&quot; ) # Using the dataloader/2 resolution helper field :_resolve_reference , :item do resolve dataloader ( Example.Loader , fn _parent , args , _res -&gt; %{ batch : { { :one , Example.Item } , %{ } } , item : [ item_id : args . item_id ] } end ) end end object :verbose_item do key_fields ( &quot;item_id&quot; ) # Using the on_load/2 resolution helper field :_resolve_reference , :verbose_item do resolve fn %{ item_id : id } , %{ context : %{ loader : loader } } -&gt; batch_key = { :one , Example.Item , %{ } } item_key = [ item_id : id ] loader |&gt; Dataloader . load ( Example.Loader , batch_key , item_key ) |&gt; on_load ( fn loader -&gt; result = Dataloader . get ( loader , Example.Loader , batch_key , item_key ) { :ok , result } end ) end end end Resolving structs in _entities queries If you need to resolve your struct to a specific type in your schema you can implement the Absinthe.Federation.Schema.EntityUnion.Resolver protocol like this: defmodule MySchema do @type t :: % __MODULE__ { id : String . t ( ) } defstruct id : &quot;&quot; defimpl Absinthe.Federation.Schema.EntityUnion.Resolver do def resolve_type ( _ , _ ) , do : :my_schema_object_name end end Federation v2 You can import Apollo Federation v2 directives by extending your top-level schema with the @link directive. defmodule Example.Schema do use Absinthe.Schema use Absinthe.Federation.Schema + extend schema do + directive :link , + url : &quot;https://specs.apollo.dev/federation/v2.7&quot; , + import : [ &quot;@authenticated&quot; , &quot;@extends&quot; , &quot;@external&quot; , &quot;@inaccessible&quot; , &quot;@key&quot; , &quot;@override&quot; , &quot;@policy&quot; , &quot;@provides&quot; , &quot;@requires&quot; , &quot;@requiresScopes&quot; , &quot;@shareable&quot; , &quot;@tag&quot; , &quot;@composeDirective&quot; , &quot;@interfaceObject&quot; + ] + end query do ... end end Namespacing and directive renaming with @link @link directive supports namespacing and directive renaming (only on Absinthe &gt;= 1.7.2 ) according to the specs. defmodule Example.Schema do use Absinthe.Schema use Absinthe.Federation.Schema + extend schema do + directive :link , + url : &quot;https://specs.apollo.dev/federation/v2.3&quot; , + import : [ %{ &quot;name&quot; =&gt; &quot;@key&quot; , &quot;as&quot; =&gt; &quot;@primaryKey&quot; } ] , # directive renaming + as : &quot;federation&quot; # namespacing + end query do ... end end","ref":"readme.html#usage-macro-based-schemas","title":"Absinthe.Federation - Usage (macro based schemas)","type":"extras"},{"doc":"See additional documentation, including guides, in the Absinthe.Federation hexdocs .","ref":"readme.html#more-documentation","title":"Absinthe.Federation - More Documentation","type":"extras"},{"doc":"Refer to the Contributing Guide .","ref":"readme.html#contributing","title":"Absinthe.Federation - Contributing","type":"extras"},{"doc":"See LICENSE","ref":"readme.html#license","title":"Absinthe.Federation - License","type":"extras"},{"doc":"We want this community to be friendly and respectful to each other. Please follow it in all your interactions with the project.","ref":"contributing.html","title":"Contributing","type":"extras"},{"doc":"To get started with the project, run mix deps.get in the root directory to install the required dependencies: $ mix deps.get Commit message convention We follow the conventional commits specification for our commit messages: fix : bug fixes, e.g. fix crash due to deprecated method. feat : new features, e.g. add new method to the module. refactor : code refactor, e.g. migrate from class components to hooks. docs : changes into documentation, e.g. add usage example for the module.. test : adding or updating tests, eg add integration tests using detox. chore : tooling changes, e.g. change CI config. Sending a pull request Working on your first pull request? You can learn how from this free series: How to Contribute to an Open Source Project on GitHub . When you're sending a pull request: Prefer small pull requests focused on one change. Verify that formatter and tests are passing. Review the documentation to make sure it looks good. Follow the pull request template when opening a pull request. For pull requests that change the API or implementation, discuss with maintainers first by opening an issue.","ref":"contributing.html#development-workflow","title":"Contributing - Development workflow","type":"extras"},{"doc":"Please remember that all interactions in our official spaces follow our Code of Conduct .","ref":"contributing.html#code-of-conduct","title":"Contributing - Code of Conduct","type":"extras"},{"doc":"MIT License Copyright (c) 2024 BILL Operations, LLC. Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the &quot;Software&quot;), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions: The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.","ref":"license.html","title":"License","type":"extras"},{"doc":"","ref":"code_of_conduct.html","title":"Code of Conduct","type":"extras"},{"doc":"We as members, contributors, and leaders pledge to make participation in our community a harassment-free experience for everyone, regardless of age, body size, visible or invisible disability, ethnicity, sex characteristics, gender identity and expression, level of experience, education, socio-economic status, nationality, personal appearance, race, religion, or sexual identity and orientation. We pledge to act and interact in ways that contribute to an open, welcoming, diverse, inclusive, and healthy community.","ref":"code_of_conduct.html#our-pledge","title":"Code of Conduct - Our Pledge","type":"extras"},{"doc":"Examples of behavior that contributes to a positive environment for our community include: Demonstrating empathy and kindness toward other people Being respectful of differing opinions, viewpoints, and experiences Giving and gracefully accepting constructive feedback Accepting responsibility and apologizing to those affected by our mistakes, and learning from the experience Focusing on what is best not just for us as individuals, but for the overall community Examples of unacceptable behavior include: The use of sexualized language or imagery, and sexual attention or advances of any kind Trolling, insulting or derogatory comments, and personal or political attacks Public or private harassment Publishing others' private information, such as a physical or email address, without their explicit permission Other conduct which could reasonably be considered inappropriate in a professional setting","ref":"code_of_conduct.html#our-standards","title":"Code of Conduct - Our Standards","type":"extras"},{"doc":"Community leaders are responsible for clarifying and enforcing our standards of acceptable behavior and will take appropriate and fair corrective action in response to any behavior that they deem inappropriate, threatening, offensive, or harmful. Community leaders have the right and responsibility to remove, edit, or reject comments, commits, code, wiki edits, issues, and other contributions that are not aligned to this Code of Conduct, and will communicate reasons for moderation decisions when appropriate.","ref":"code_of_conduct.html#enforcement-responsibilities","title":"Code of Conduct - Enforcement Responsibilities","type":"extras"},{"doc":"This Code of Conduct applies within all community spaces, and also applies when an individual is officially representing the community in public spaces. Examples of representing our community include using an official e-mail address, posting via an official social media account, or acting as an appointed representative at an online or offline event.","ref":"code_of_conduct.html#scope","title":"Code of Conduct - Scope","type":"extras"},{"doc":"Instances of abusive, harassing, or otherwise unacceptable behavior may be reported to the community leaders responsible for enforcement at [INSERT CONTACT METHOD]. All complaints will be reviewed and investigated promptly and fairly. All community leaders are obligated to respect the privacy and security of the reporter of any incident.","ref":"code_of_conduct.html#enforcement","title":"Code of Conduct - Enforcement","type":"extras"},{"doc":"Community leaders will follow these Community Impact Guidelines in determining the consequences for any action they deem in violation of this Code of Conduct: 1. Correction Community Impact : Use of inappropriate language or other behavior deemed unprofessional or unwelcome in the community. Consequence : A private, written warning from community leaders, providing clarity around the nature of the violation and an explanation of why the behavior was inappropriate. A public apology may be requested. 2. Warning Community Impact : A violation through a single incident or series of actions. Consequence : A warning with consequences for continued behavior. No interaction with the people involved, including unsolicited interaction with those enforcing the Code of Conduct, for a specified period of time. This includes avoiding interactions in community spaces as well as external channels like social media. Violating these terms may lead to a temporary or permanent ban. 3. Temporary Ban Community Impact : A serious violation of community standards, including sustained inappropriate behavior. Consequence : A temporary ban from any sort of interaction or public communication with the community for a specified period of time. No public or private interaction with the people involved, including unsolicited interaction with those enforcing the Code of Conduct, is allowed during this period. Violating these terms may lead to a permanent ban. 4. Permanent Ban Community Impact : Demonstrating a pattern of violation of community standards, including sustained inappropriate behavior, harassment of an individual, or aggression toward or disparagement of classes of individuals. Consequence : A permanent ban from any sort of public interaction within the community.","ref":"code_of_conduct.html#enforcement-guidelines","title":"Code of Conduct - Enforcement Guidelines","type":"extras"},{"doc":"This Code of Conduct is adapted from the Contributor Covenant , version 2.0, available at https://www.contributor-covenant.org/version/2/0/code_of_conduct.html . Community Impact Guidelines were inspired by Mozilla's code of conduct enforcement ladder . For answers to common questions about this code of conduct, see the FAQ at https://www.contributor-covenant.org/faq . Translations are available at https://www.contributor-covenant.org/translations .","ref":"code_of_conduct.html#attribution","title":"Code of Conduct - Attribution","type":"extras"}]